codeforces C.前卫树: 连通块+组合数学+容斥

题目链接:
题目大意:
给你一棵树(一个没有循环的连通无向图) ñ顶点。每一个n - 1 树的边缘用黑色或红色着色。

你也给了一个整数 k,考虑序列k顶点。我们叫一个序列[ a1,a2,… ,aķ] 如果它满足以下标准则很好:

我们将从树上开始走路径(可能多次访问相同的边/顶点) 开始于a1 结束于 ak。每次都走最短路径

如果你在这个过程中至少走过一条黑色边缘,那么顺序是好的。
在这里插入图片描述
k=3时,[1,4,7], [5,5,3] and [2,3,7]是好的。 [1,4,6], [5,5,5], [3,7,3]不是好的。

问你好的序列数量,mod(1e9+7)
在这里插入图片描述在这里插入图片描述
思路:当时一直从正面考虑,满足的个数。无法容斥。只要从反面考虑。所有可能的-不满足的。
两点的路径没有经过黑色边,那么他们就在一个连通块内。
答案就是:
在这里插入图片描述
p:每个连通块的点数量。

求连通块:dfs起点不经过黑边,能访问到的所有点就是一个连通块。每次得到一个连通块直接快速幂就行了。
注意:因为都是mod过后的,得到的答案可能为负。因为答案一定是正数,所以自己每次调整一下。

ans=(ans+mod)%mod
#include<bits/stdc++.h>
typedef long long LL;
#define p1 first
#define p2 second
using namespace std;
const int mod=1e9+7;
//memset(a, 0, sizeof(a));
//stack堆栈 queue队列 priority_queue优先队列
//vector向量 multiset平衡二叉树 deque双端队列
//pair{T1 first;T2 second;} greater<T>
//unordered_map 哈希map

vector<pair<int, int> > v[200005];
int vis[200005];
LL cut=0;

//快速乘法(a*b)%mod
LL quick_mul(LL a, LL b)
{
    LL ans=0;
    while(b)
    {
        if(b&1)
            ans=(ans+a)%mod;
        a=(a+a)%mod;

        b>>=1;
    }
    return ans;
}

//快速幂(a^b)%mod
LL quick_pow(LL a, LL b)
{
    LL ans=1;
    while(b)
    {
        if(b&1)
            ans=quick_mul(ans, a);
        a=quick_mul(a, a);

        b>>=1;
    }
    return ans;
}

int dfs(int u)
{
    vis[u]=1;
    cut++;
    for(int i=0;i<v[u].size();i++)
    {
        int t=v[u][i].p1;
        if(!vis[t]&&!v[u][i].p2)
        {
            dfs(t);
        }
    }
}

int main()
{
	LL n, k;
	cin>>n>>k;
	for(int i=0;i<n-1;i++)
    {
        int u, t, w;
        scanf("%d%d%d",&u,&t,&w);
        v[u].push_back({t, w});
        v[t].push_back({u, w});
    }
    memset(vis, 0, sizeof(vis));
    LL ans=quick_pow(n, k);
    for(int i=1;i<=n;i++)
    {
        cut=0;
        if(!vis[i])
        {
            dfs(i);
        }
        ans-=quick_pow(cut, k);
        ans=(ans+mod)%mod;
    }
    cout<<ans<<endl;

	return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
The problem statement can be found at Codeforces website. Approach: Let's start by looking at some examples: - 1, 2, 3, 4, 5 → No moves needed. - 2, 1, 3, 5, 4 → One move needed: swap index 1 and 2. - 5, 4, 3, 2, 1 → Two moves needed: swap index 1 and 5, then swap index 2 and 4. We can observe that in order to minimize the number of moves, we need to sort the array in non-descending order and keep track of the number of swaps we make. We can use bubble sort to sort the array and count the number of swaps. Let's see how bubble sort works: - Start from the first element, compare it with the second element, and swap them if the second element is smaller. - Move to the second element, compare it with the third element, and swap them if the third element is smaller. - Continue this process until the second-to-last element. At this point, the largest element is in the last position. - Repeat the above process for the remaining elements, but exclude the last position. In each iteration of the above process, we can count the number of swaps made. Therefore, the total number of swaps needed to sort the array can be obtained by summing up the number of swaps made in each iteration. Implementation: We can implement the above approach using a simple bubble sort algorithm. Here's the code: - First, we read the input array and store it in a vector. - We define a variable to keep track of the total number of swaps made and set it to 0. - We run a loop from the first element to the second-to-last element. - In each iteration of the above loop, we run another loop from the first element to the second-to-last element minus the current iteration index. - In each iteration of the inner loop, we compare the current element with the next element and swap them if the next element is smaller. - If a swap is made, we increment the total number of swaps made. - Finally, we output the total number of swaps made. Time Complexity: The time complexity of bubble sort is O(n^2). Therefore, the overall time complexity of the solution is O(n^2). Space Complexity: We are using a vector to store the input array. Therefore, the space complexity of the solution is O(n). Let's see the implementation of the solution.

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值